﻿Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

Imports System.Windows.Documents

Partial Public Class Window1
	Public Sub New()
		MyBase.New()

		Me.InitializeComponent()

		' Insert code required on object creation below this point.
	End Sub

    ' Update the menu's checkboxes.
    Private Sub mnuFontStyle_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        ' Bold.
        Dim fw_obj As Object = rchBody.Selection.GetPropertyValue( _
            TextElement.FontWeightProperty)
        If (TypeOf (fw_obj) Is FontWeight) Then
            Dim fw As FontWeight = DirectCast(fw_obj, FontWeight)
            mnuFontStyleBold.IsChecked = (fw = FontWeights.Bold)
        Else
            mnuFontStyleBold.IsChecked = False
        End If

        ' Italic.
        Dim it_obj As Object = rchBody.Selection.GetPropertyValue( _
            TextElement.FontStyleProperty)
        If (TypeOf (it_obj) Is FontStyle) Then
            Dim it As FontStyle = DirectCast(it_obj, FontStyle)
            mnuFontStyleItalic.IsChecked = (it = FontStyles.Italic)
        Else
            mnuFontStyleItalic.IsChecked = False
        End If

        ' Underlined.
        Dim ul_obj As Object = rchBody.Selection.GetPropertyValue( _
            Paragraph.TextDecorationsProperty)
        If (TypeOf (ul_obj) Is TextDecorationCollection) Then
            Dim decorations As TextDecorationCollection = _
                DirectCast(ul_obj, TextDecorationCollection)
            mnuFontStyleUnderline.IsChecked = ((decorations.Count > 0) AndAlso _
                (decorations(0).Location = TextDecorationLocation.Underline))
        Else
            mnuFontStyleUnderline.IsChecked = False
        End If
    End Sub

    ' Update the FontSize menu.
    Private Sub mnuFontSize_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim fs_obj As Object = rchBody.Selection.GetPropertyValue( _
            TextElement.FontSizeProperty)
        If (TypeOf (fs_obj) Is Double) Then
            Dim fs As Double = fs_obj
            mnuFontSizeSmall.IsChecked = (fs < 16.0)
            mnuFontSizeMedium.IsChecked = ((fs >= 16.0) AndAlso (fs < 22.0))
            mnuFontSizeLarge.IsChecked = (fs >= 22.0)
        Else
            mnuFontSizeSmall.IsChecked = False
            mnuFontSizeMedium.IsChecked = False
            mnuFontSizeLarge.IsChecked = False
        End If
    End Sub

    ' Set the selected font's size.
    Private Sub FontSize_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select (mnu.Header.ToString())
            Case "_Small"
                rchBody.Selection.ApplyPropertyValue(TextElement.FontSizeProperty, 10.0)
            Case "_Medium"
                rchBody.Selection.ApplyPropertyValue(TextElement.FontSizeProperty, 16.0)
            Case "_Large"
                rchBody.Selection.ApplyPropertyValue(TextElement.FontSizeProperty, 22.0)
        End Select
    End Sub

    ' Update the Text Color menu.
    Private Sub mnuFontTextColor_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim br_obj As Object = rchBody.Selection.GetPropertyValue( _
            TextElement.ForegroundProperty)
        If (TypeOf (br_obj) Is SolidColorBrush) Then
            Dim br As SolidColorBrush = DirectCast(br_obj, SolidColorBrush)
            mnuFontTextColorBlack.IsChecked = (br.Color.Equals(Colors.Black))
            mnuFontTextColorRed.IsChecked = (br.Color.Equals(Colors.Red))
            mnuFontTextColorGreen.IsChecked = (br.Color.Equals(Colors.Green))
            mnuFontTextColorBlue.IsChecked = (br.Color.Equals(Colors.Blue))
        Else
            mnuFontTextColorBlack.IsChecked = False
            mnuFontTextColorRed.IsChecked = False
            mnuFontTextColorGreen.IsChecked = False
            mnuFontTextColorBlue.IsChecked = False
        End If
    End Sub

    ' Set the selection's text color.
    Private Sub mnuFontTextColor_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select (mnu.Header.ToString())
            Case "_Black"
                rchBody.Selection.ApplyPropertyValue(TextElement.ForegroundProperty, Brushes.Black)
            Case "_Red"
                rchBody.Selection.ApplyPropertyValue(TextElement.ForegroundProperty, Brushes.Red)
            Case "_Green"
                rchBody.Selection.ApplyPropertyValue(TextElement.ForegroundProperty, Brushes.Green)
            Case "B_lue"
                rchBody.Selection.ApplyPropertyValue(TextElement.ForegroundProperty, Brushes.Blue)
        End Select
    End Sub

    ' Update the Background Color menu.
    Private Sub mnuFontBackgroundColor_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim br_obj As Object = rchBody.Selection.GetPropertyValue( _
            TextElement.BackgroundProperty)
        If (TypeOf (br_obj) Is SolidColorBrush) Then
            Dim br As SolidColorBrush = DirectCast(br_obj, SolidColorBrush)
            mnuFontBackgroundColorLightBlue.IsChecked = (br.Color.Equals(Colors.LightBlue))
            mnuFontBackgroundColorWhite.IsChecked = (br.Color.Equals(Colors.White))
            mnuFontBackgroundColorYellow.IsChecked = (br.Color.Equals(Colors.Yellow))
        Else
            mnuFontBackgroundColorLightBlue.IsChecked = False
            mnuFontBackgroundColorWhite.IsChecked = False
            mnuFontBackgroundColorYellow.IsChecked = False
        End If
    End Sub

    ' Set the background color.
    Private Sub mnuFontBackgroundColor_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select (mnu.Header.ToString())
            Case "_Light Blue"
                rchBody.Selection.ApplyPropertyValue(TextElement.BackgroundProperty, Brushes.LightBlue)
            Case "_White"
                rchBody.Selection.ApplyPropertyValue(TextElement.BackgroundProperty, Brushes.White)
            Case "_Yellow"
                rchBody.Selection.ApplyPropertyValue(TextElement.BackgroundProperty, Brushes.Yellow)
        End Select
    End Sub

    ' Update the font family menu.
    Private Sub mnuFontFamily_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim ff_obj As Object = rchBody.Selection.GetPropertyValue( _
            TextElement.FontFamilyProperty)
        If (TypeOf (ff_obj) Is FontFamily) Then
            Dim ff As FontFamily = DirectCast(ff_obj, FontFamily)
            mnuFontFamilyTimes.IsChecked = (ff.Equals(New FontFamily("Times New Roman")))
            mnuFontFamilyArial.IsChecked = (ff.Equals(New FontFamily("Arial")))
            mnuFontFamilyCourier.IsChecked = (ff.Equals(New FontFamily("Courier New")))
        Else
            mnuFontFamilyTimes.IsChecked = False
            mnuFontFamilyArial.IsChecked = False
            mnuFontFamilyCourier.IsChecked = False
        End If
    End Sub

    ' Set the font family.
    Private Sub mnuFontFamily_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select (mnu.Header.ToString())
            Case "_Times New Roman"
                rchBody.Selection.ApplyPropertyValue(TextElement.FontFamilyProperty, New FontFamily("Times New Roman"))
            Case "_Arial"
                rchBody.Selection.ApplyPropertyValue(TextElement.FontFamilyProperty, New FontFamily("Arial"))
            Case "_Courier New"
                rchBody.Selection.ApplyPropertyValue(TextElement.FontFamilyProperty, New FontFamily("Courier New"))
        End Select
    End Sub

    ' Enable or disable the Undo and Redo commands.
    Private Sub mnuEdit_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        mnuEditUndo.IsEnabled = (rchBody.CanUndo)
        mnuEditRedo.IsEnabled = (rchBody.CanRedo)
    End Sub

    ' Undo.
    Private Sub mnuEditUndo_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        rchBody.Undo()
    End Sub

    ' Redo.
    Private Sub mnuEditRedo_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        rchBody.Redo()
    End Sub

    ' Toggle the selection's bullet state.
    Private Sub mnuParaBullet_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        EditingCommands.ToggleBullets.Execute(Nothing, rchBody)
    End Sub

    ' Toggle the selection's number state.
    Private Sub mnuParaNumber_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        EditingCommands.ToggleNumbering.Execute(Nothing, rchBody)
    End Sub
End Class
