﻿Imports System
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Navigation

Imports System.Windows.Documents

Partial Public Class Window1
    Public Sub New()
        MyBase.New()

        Me.InitializeComponent()

        ' Insert code required on object creation below this point.
    End Sub

    ' Update the menu's checkboxes.
    Private Sub mnuFontStyle_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        ' Bold.
        mnuFontStyleBold.IsChecked = IsBold()

        ' Italic.
        mnuFontStyleItalic.IsChecked = IsItalic()

        ' Underlined.
        mnuFontStyleUnderline.IsChecked = IsUnderlined()
    End Sub

    ' Return true if the text is bold.
    Private Function IsBold() As Boolean
        Dim fw_obj As Object = txtBody.GetValue( _
            TextElement.FontWeightProperty)
        If (TypeOf (fw_obj) Is FontWeight) Then
            Dim fw As FontWeight = DirectCast(fw_obj, FontWeight)
            Return (fw = FontWeights.Bold)
        Else
            Return False
        End If
    End Function

    ' Return True if the text is italicized.
    Private Function IsItalic() As Boolean
        Dim it_obj As Object = txtBody.GetValue( _
            TextElement.FontStyleProperty)
        If (TypeOf (it_obj) Is FontStyle) Then
            Dim it As FontStyle = DirectCast(it_obj, FontStyle)
            Return (it = FontStyles.Italic)
        Else
            Return False
        End If
    End Function

    ' Return True if the text is underlined.
    Private Function IsUnderlined() As Boolean
        Dim ul_obj As Object = txtBody.GetValue( _
            Paragraph.TextDecorationsProperty)
        If (TypeOf (ul_obj) Is TextDecorationCollection) Then
            Dim decorations As TextDecorationCollection = _
                DirectCast(ul_obj, TextDecorationCollection)
            Return ((decorations.Count > 0) AndAlso _
                (decorations(0).Location = TextDecorationLocation.Underline))
        Else
            Return False
        End If
    End Function

    ' Toggle bold.
    Private Sub mnuFontBold_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        If IsBold() Then
            txtBody.SetValue(FontWeightProperty, FontWeights.Normal)
        Else
            txtBody.SetValue(FontWeightProperty, FontWeights.Bold)
        End If
    End Sub

    ' Toggle italic.
    Private Sub mnuFontItalic_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        If IsItalic() Then
            txtBody.SetValue(FontStyleProperty, FontStyles.Normal)
        Else
            txtBody.SetValue(FontStyleProperty, FontStyles.Italic)
        End If
    End Sub

    ' Toggle underline.
    Private Sub mnuFontUnderline_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim decorations As New TextDecorationCollection

        If Not IsUnderlined() Then
            Dim text_decoration As New TextDecoration()
            text_decoration.Location = TextDecorationLocation.Underline
            decorations.Add(text_decoration)
        End If

        txtBody.SetValue(Paragraph.TextDecorationsProperty, decorations)
    End Sub

    ' Update the FontSize menu.
    Private Sub mnuFontSize_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim fs_obj As Object = txtBody.GetValue( _
            TextElement.FontSizeProperty)
        If (TypeOf (fs_obj) Is Double) Then
            Dim fs As Double = fs_obj
            mnuFontSizeSmall.IsChecked = (fs < 16.0)
            mnuFontSizeMedium.IsChecked = ((fs >= 16.0) AndAlso (fs < 22.0))
            mnuFontSizeLarge.IsChecked = (fs >= 22.0)
        Else
            mnuFontSizeSmall.IsChecked = False
            mnuFontSizeMedium.IsChecked = False
            mnuFontSizeLarge.IsChecked = False
        End If
    End Sub

    ' Set the selected font's size.
    Private Sub FontSize_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select Case (mnu.Header.ToString())
            Case "_Small"
                txtBody.SetValue(TextElement.FontSizeProperty, 10.0)
            Case "_Medium"
                txtBody.SetValue(TextElement.FontSizeProperty, 16.0)
            Case "_Large"
                txtBody.SetValue(TextElement.FontSizeProperty, 22.0)
        End Select
    End Sub

    ' Update the Text Color menu.
    Private Sub mnuFontTextColor_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim br_obj As Object = txtBody.GetValue( _
            TextElement.ForegroundProperty)
        If (TypeOf (br_obj) Is SolidColorBrush) Then
            Dim br As SolidColorBrush = DirectCast(br_obj, SolidColorBrush)
            mnuFontTextColorBlack.IsChecked = (br.Color.Equals(Colors.Black))
            mnuFontTextColorRed.IsChecked = (br.Color.Equals(Colors.Red))
            mnuFontTextColorGreen.IsChecked = (br.Color.Equals(Colors.Green))
            mnuFontTextColorBlue.IsChecked = (br.Color.Equals(Colors.Blue))
        Else
            mnuFontTextColorBlack.IsChecked = False
            mnuFontTextColorRed.IsChecked = False
            mnuFontTextColorGreen.IsChecked = False
            mnuFontTextColorBlue.IsChecked = False
        End If
    End Sub

    ' Set the selection's text color.
    Private Sub mnuFontTextColor_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select Case (mnu.Header.ToString())
            Case "_Black"
                txtBody.SetValue(TextElement.ForegroundProperty, Brushes.Black)
            Case "_Red"
                txtBody.SetValue(TextElement.ForegroundProperty, Brushes.Red)
            Case "_Green"
                txtBody.SetValue(TextElement.ForegroundProperty, Brushes.Green)
            Case "B_lue"
                txtBody.SetValue(TextElement.ForegroundProperty, Brushes.Blue)
        End Select
    End Sub

    ' Update the Background Color menu.
    Private Sub mnuFontBackgroundColor_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim br_obj As Object = txtBody.GetValue( _
            TextElement.BackgroundProperty)
        If (TypeOf (br_obj) Is SolidColorBrush) Then
            Dim br As SolidColorBrush = DirectCast(br_obj, SolidColorBrush)
            mnuFontBackgroundColorLightBlue.IsChecked = (br.Color.Equals(Colors.LightBlue))
            mnuFontBackgroundColorWhite.IsChecked = (br.Color.Equals(Colors.White))
            mnuFontBackgroundColorYellow.IsChecked = (br.Color.Equals(Colors.Yellow))
        Else
            mnuFontBackgroundColorLightBlue.IsChecked = False
            mnuFontBackgroundColorWhite.IsChecked = False
            mnuFontBackgroundColorYellow.IsChecked = False
        End If
    End Sub

    ' Set the background color.
    Private Sub mnuFontBackgroundColor_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select Case (mnu.Header.ToString())
            Case "_Light Blue"
                txtBody.Background = Brushes.LightBlue
            Case "_White"
                txtBody.Background = Brushes.White
            Case "_Yellow"
                txtBody.Background = Brushes.Yellow
        End Select
    End Sub

    ' Update the font family menu.
    Private Sub mnuFontFamily_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim ff_obj As Object = txtBody.GetValue( _
            TextElement.FontFamilyProperty)
        If (TypeOf (ff_obj) Is FontFamily) Then
            Dim ff As FontFamily = DirectCast(ff_obj, FontFamily)
            mnuFontFamilyTimes.IsChecked = (ff.Equals(New FontFamily("Times New Roman")))
            mnuFontFamilyArial.IsChecked = (ff.Equals(New FontFamily("Arial")))
            mnuFontFamilyCourier.IsChecked = (ff.Equals(New FontFamily("Courier New")))
        Else
            mnuFontFamilyTimes.IsChecked = False
            mnuFontFamilyArial.IsChecked = False
            mnuFontFamilyCourier.IsChecked = False
        End If
    End Sub

    ' Set the font family.
    Private Sub mnuFontFamily_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim mnu As MenuItem = DirectCast(sender, MenuItem)
        Select Case (mnu.Header.ToString())
            Case "_Times New Roman"
                txtBody.SetValue(TextElement.FontFamilyProperty, New FontFamily("Times New Roman"))
            Case "_Arial"
                txtBody.SetValue(TextElement.FontFamilyProperty, New FontFamily("Arial"))
            Case "_Courier New"
                txtBody.SetValue(TextElement.FontFamilyProperty, New FontFamily("Courier New"))
        End Select
    End Sub

    ' Enable or disable the Undo and Redo commands.
    Private Sub mnuEdit_SubmenuOpened(ByVal sender As Object, ByVal e As RoutedEventArgs)
        mnuEditUndo.IsEnabled = (txtBody.CanUndo)
        mnuEditRedo.IsEnabled = (txtBody.CanRedo)
    End Sub

    ' Undo.
    Private Sub mnuEditUndo_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        txtBody.Undo()
    End Sub

    ' Redo.
    Private Sub mnuEditRedo_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        txtBody.Redo()
    End Sub

    ' Toggle the selection's bullet state.
    Private Sub mnuParaBullet_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        EditingCommands.ToggleBullets.Execute(Nothing, txtBody)
    End Sub

    ' Toggle the selection's number state.
    Private Sub mnuParaNumber_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
        EditingCommands.ToggleNumbering.Execute(Nothing, txtBody)
    End Sub

    ' Left align the text.
    Private Sub mnuParaAlignLeft_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        txtBody.TextAlignment = TextAlignment.Left
    End Sub

    ' Center the text.
    Private Sub mnuParaAlignCenter_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        txtBody.TextAlignment = TextAlignment.Center
    End Sub

    ' Right align the text.
    Private Sub mnuParaAlignRight_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        txtBody.TextAlignment = TextAlignment.Right
    End Sub

    ' Justify the text.
    Private Sub mnuParaAlignJustify_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        txtBody.TextAlignment = TextAlignment.Justify
    End Sub
End Class
